# SLIDES_DIR est un dossier où se trouvent les slides
# TIMES_FILE est un fichier txt avec une paire de chiffres par ligne, séparés par une virgule. le premier chiffre indique le moment en seconde à la quelle la slide doit apparaitre, et le second le moment ou elle doit disparaitre
# START_FILE est le fichier vidéo originel

# le positionnement des slides se fait dans la commande ffmpeg
# overlay={position X par rapport au coin en haut a gauche en pixels}/{position Y par rapport au coin en haut a gauche en pixels}
# W indique la largeur de la vidéo, et H la hauteur de la vidéo
# avec des valeurs absolues en pixel, ça s'écrit e.g. overlay=25/25
import os

START_FILE = "test.mp4"
TIMES_FILE = "./times.txt"
SLIDES_DIR = "./slides"


with open(TIMES_FILE) as f:
    times = [time.rstrip() for time in f]
    slides = [s for s in os.listdir(SLIDES_DIR)]
    
    i = 0
    input_file = START_FILE
    output_file = f"output{i}.mp4"
    for t in times:
        start = t.split(",")[0]
        end = t.split(",")[1]
                
        os.system(f'ffmpeg -y -hide_banner -i {input_file} -i {SLIDES_DIR}/{slides[i]} -filter_complex "[0:v][1:v] overlay=(W-w):0:enable=\'between(t,{start},{end})\'" -pix_fmt yuv420p -c:a copy {output_file}')
        
        i += 1
        input_file = output_file
        output_file = f"output{i}.mp4"
    
    print("\n")
    print(f"done!")
